% demonstrations filtering 
% make Sinfonietta 1 channel ... 
s = wavread('sinf.wav'); 
s = sum(s'); 
Fs = 44100; Fs2 = Fs/2; 
% design some filters and do the filtering ...
% low pass until 500Hz 
Wp = 500/Fs2; Ws = 1000/Fs2; Rp =  3; Rs = 20; 
[N,Wp] = ellipord(Wp, Ws, Rp, Rs); 
[B,A] = ellip(N,Rp,Rs,Wp); 
freqz(B,A,512,Fs); print -dpng ../fig/low.png 
y = filter(B,A,s); wavwrite(y,Fs,16,'low.wav'); 
% high pass above 5000Hz 
Wp = 4000/Fs2; Ws = 5000/Fs2; Rp =  3; Rs = 20; 
[N,Wp] = ellipord(Wp, Ws, Rp, Rs); 
[B,A] = ellip(N,Rp,Rs,Wp,'high'); 
freqz(B,A,512,Fs); print -dpng ../fig/high.png 
y = filter(B,A,s); wavwrite(y,Fs,16,'high.wav'); 
% telephone channel
Wp = [300 3400]/Fs2; Ws = [200 4000]/Fs2; Rp =  3; Rs = 20; 
[N,Wp] = ellipord(Wp, Ws, Rp, Rs); 
[B,A] = ellip(N,Rp,Rs,Wp); 
freqz(B,A,512,Fs); print -dpng ../fig/pass.png 
y = filter(B,A,s); wavwrite(y,Fs,16,'pass.wav'); 

% cosine 1kHz
n = 1:length(s); 
s1 = s + 0.2 * cos (2 * pi * 1000 / Fs * n); 
wavwrite(s1,Fs,16,'s1.wav');
% band-stop around 1k ...
Wp = [950 1050]/Fs2; Ws = [975 1025]/Fs2; Rp =  3; Rs = 40; 
[N,Wp] = ellipord(Wp, Ws, Rp, Rs); 
[B,A] = ellip(N,Rp,Rs,Wp,'stop');
freqz(B,A,512,Fs); print -dpng ../fig/1kstop.png 
y = filter(B,A,s); wavwrite(y,Fs,16,'s1_1k_stopped.wav'); 

% matched filter 
% just pulses 
n = 1:10000; 
x = zeros(size(n)); 
x([600   5600    8900]) = 1; 
subplot(211); plot(x); 
y = x + randn(1, 10000); 
subplot(212); plot(y); print -dpng ../fig/spikes_in_noise.png 

% matched filter 
b = randn(1,100); 
subplot(411); plot(b); 
x = zeros(size(n)); 
x(600-99:600) = b; 
x(5600-99:5600) = b; 
x(8900-99:8900) = b; 
subplot(412); plot(x); 
y = x + randn(1, 10000); 
subplot(413); plot(y); 
yy = filter(fliplr(b),1,y); 
subplot(414); plot(yy);  print -dpng ../fig/matched_filter.png 

% ----------------------------------------------------------------------
% big filter - want to filter "letajici prase" and let only freqs between 1 and 2 kHz. 
Fs = 8000; Fs2 = Fs/2; 
Wp = [1000 2000]/Fs2; Ws = [800 2200]/Fs2; Rp =  3; Rs = 20; 
[N,Wp] = ellipord(Wp, Ws, Rp, Rs); 
[B,A] = ellip(N,Rp,Rs,Wp); 
freqz(B,A,512,Fs); print -dpng ../fig/pass_1_2k.png 
% produce letajici prase for check ... 
ff = fopen ('test.l16', 'r'); s = fread (ff, [1 inf], 'short'); fclose(ff); 
ss = filter (B,A,s); 
ff = fopen ('test_fil_matlab.l16', 'w'); fwrite (ff, ss, 'short'); fclose(ff); 

% checking with the c-file with the same params ... ouff, after making the filter less sharp works ! 
% the online one as well, good. 

% ----------------- filcy atd ------------------------------------------
% 2s na 8000Hz
n = 1:16000; 
% cosinusovka 440Hz a sum
x = 0.5 * cos (2 * pi * 440 / 8000 * n) + 0.1 * randn(size(n)); 
plot (x); soundsc (x); % wavwrite(x,8000,16,'cos_noise.wav')

% kratky avg. filtr
B1 = ones(1,20) / 20
y1 = filter(B1,1,x); 
plot (y1); soundsc (y1); % wavwrite(y1,8000,16,'y1.wav')

% dlouhy avg. filtr
B2 = ones(1,181) / 181 
y2 = filter(B2,1,x); 
plot (y2); soundsc (y2); % wavwrite(y2,8000,16,'y2.wav')

% vroubky 
B3 = [1 -1] / 2
y3 = filter(B3,1,x); 
plot (y3); soundsc (y3); % wavwrite(y3,8000,16,'y3.wav')

% kus cosinusovky ... 
n = 1:181; 
B4 = cos (2 * pi * 440 / 8000 * n); 
plot(B4);  % osklivy hrany ... 
B4 = B4 .* sin(pi * n / 181); 
plot(B4); % trochu moc velky soucet ... 
B4 = B4 ./ sum(abs(B4)); 
plot(B4);

y4 = filter(B4,1,x); 
plot (y4); soundsc (y4); % wavwrite(y4,8000,16,'y4.wav')

% --- prase a 1kHz --- 
ff = fopen ('test.l16', 'r'); s = fread (ff, [1 inf], 'short'); fclose(ff); 
s = s- mean(s); s = s/max(abs(s)); plot(s) 
yprase = filter(B4,1,s); 
plot (yprase); soundsc (yprase); % wavwrite(yprase,8000,16,'yprase.wav')

% -------- frequency response - "measurement"  ---------------
A = [1.000000000000000,  -2.099439053163407,   3.609709467904307,  -3.636253874016913,   3.154538638938833,  -1.538016615547207,   0.622409459323563]; 
B = [0.092255013283721,  -0.120758083660268,   0.064790399505910,  -0.000000000000000,  -0.064790399505910,   0.120758083660268,  -0.092255013283721]; 
%  will produce 200 frequencis between 0 and 4000 Hz and measure what the filter does. 
% the bulb is replaced by measuring the energy per sample ... 
% will omit the beginning as it can be screwed up by the transition effect. 
freqs = linspace (0,4000,200); 
Nin = 8000; n = 1:Nin; 
% allocate for freq. char
Hmeasure = zeros(1,200); 
for ii = 1:200; 
  x = cos(2*pi*freqs(ii) / 8000 * n); 
  Ein = sum(x.^2) / Nin; 
  % filter and measure 
  y = filter(B,A,x);    %plot(n,x,n,y); pause;  %<<< comment out to see what happens !
  % take only one half and measure energy. 
  Nout = 4000; y = y(4001:8000); 
  Eout = sum(y.^2) / Nout; 
  Hmeasure(ii) = sqrt(Eout / Ein); 
end
plot(freqs, Hmeasure); 

% -------- frequency response via impulse response   ---------------
h = filter(B,A,[1 zeros(1,511)]); plot(h) 
Hfft = abs(fft(h)); Hfft = Hfft(1:257); 
ffft = linspace(0,4000,257); 
plot (ffft, Hfft); 

% -------- frequency response via transfer function by hand   ---------------
freqs = linspace (0,4000,200); 
Htran = zeros(1,200); 
P = length(A)-1; Q = length(B) - 1; 
for ii = 1:200; 
  f = freqs(ii); 
  num = 0; 
  for kk = 0:Q;
    num = num + B(kk+1) * exp (-j * 2 * pi * f / 8000 * kk); % +1 because of shitty Matlab indexing
  end
  den = 0; 
  for kk = 0:P;
    den = den + A(kk+1) * exp (-j * 2 * pi * f / 8000 * kk); % +1 because of shitty Matlab indexing
  end  % ... should go to ISS jail for this, should be heavily optimized !!! 
  Htran(ii) = abs(num / den); 
end

plot(freqs, Hmeasure, ffft, Hfft, freqs, Htran); 

% -------- frequency response via transfer by freqz   ---------------
Hfreqz = abs(freqz(B,A,200)); 

plot(freqs, Hmeasure, ffft, Hfft, freqs, Htran, freqs, Hfreqz); 
